/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distribselectGameuted on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Wikipedia Toolbar.
 *
 * The Initial Developer of the Original Code is
 * Bananeweizen
 *
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Shane A. Froebel <shane.froebel@gmail.com/bugs@bugssite.org>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 /* ***** CVS HEADERS *****
 * $Id: wikipedia_preferences_shortcuts.js,v 1.3 2006/04/15 06:10:47 froebel Exp $
 * ***** END CVS HEADERS ***** */

var wpKeys=Array('link','bold','italic','table','image','signature','weblink');
var wpKeyParts=Array();
var wpKeyIndex=-1;

function onLoadPageShortcuts() {
	loadShortcuts();
}

function selectionChanged() {
	var tree=document.getElementById('shortcut-tree');
	wpKeyIndex=tree.currentIndex;
	var edit=document.getElementById('edit');
	edit.value=getFormattedKey(wpKeyParts[wpKeyIndex][0],wpKeyParts[wpKeyIndex][1],wpKeyParts[wpKeyIndex][2]);
	document.getElementById('edit').removeAttribute("disabled");
}

function getFormattedKey(modifiers,key,keycode) {
	var val=modifiers;
	if (val!="") {
		val=val+" ";
	}
	val=val+key;
	return val;
}

function updateLabel(index) {
	var label = getFormattedKey(wpKeyParts[index][0],wpKeyParts[index][1],wpKeyParts[index][2]);
	var item=document.getElementById('wp-label-'+wpKeys[index]);
	item.setAttribute("label",label);
}

function Recognize(event) {
	event.preventDefault();
	event.stopPropagation();

	var modifiers = [];
	if(event.altKey) modifiers.push("alt");
	if(event.ctrlKey) modifiers.push("control");
	if(event.metaKey) modifiers.push("meta");
	if(event.shiftKey) modifiers.push("shift");

	modifiers = modifiers.join(" ");

	var key = "";
	var keycode = "";
	if (event.charCode)
		key = String.fromCharCode(event.charCode).toUpperCase();
	else {
		keycode = gVKNames[event.keyCode];
		if(!keycode) return;
	}

	var parts=new Array(modifiers, key, keycode);
	wpKeyParts[wpKeyIndex]=parts;

	var edit=document.getElementById('edit');
	var label = getFormattedKey(modifiers,key,keycode);
	edit.value = label;
	updateLabel(wpKeyIndex);

	storeShortcuts();
}

function removeShortcut() {
	if (wpKeyIndex>-1) {
		wpKeyParts[wpKeyIndex][0]="";
		wpKeyParts[wpKeyIndex][1]="";
		wpKeyParts[wpKeyIndex][2]="";
		updateLabel(wpKeyIndex);
		storeShortcuts();
		document.getElementById('edit').value="";
	}
}

function storeShortcuts() {
	var wbPrefs = getPreferences();
	for (var i=0;i<wpKeys.length;i++) {
		var modifiers=wpKeyParts[i][0];
		var key=wpKeyParts[i][1];
		var keycode=wpKeyParts[i][2];
		wbPrefs.setCharPref(OPTION_SHORTCUT+"."+wpKeys[i]+".modifiers",modifiers);
		wbPrefs.setCharPref(OPTION_SHORTCUT+"."+wpKeys[i]+".key",key);
		wbPrefs.setCharPref(OPTION_SHORTCUT+"."+wpKeys[i]+".keycode",keycode);
	}
}

function loadShortcuts() {
	var wbPrefs = getPreferences();
	for (var i=0;i<wpKeys.length;i++) {
		var modifiers="";
		var key="";
		var keycode="";
		try {
			modifiers=wbPrefs.getCharPref(OPTION_SHORTCUT+"."+wpKeys[i]+".modifiers");
			key=wbPrefs.getCharPref(OPTION_SHORTCUT+"."+wpKeys[i]+".key");
			keycode=wbPrefs.getCharPref(OPTION_SHORTCUT+"."+wpKeys[i]+".keycode");
		}
		catch (e) {
		}
		var parts=new Array(modifiers, key, keycode);
		wpKeyParts.push(parts);
		updateLabel(i);
	}
}