/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distribselectGameuted on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Wikipedia Toolbar.
 *
 * The Initial Developer of the Original Code is
 * Bananeweizen
 *
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Shane A. Froebel <shane.froebel@gmail.com/bugs@bugssite.org>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 /* ***** CVS HEADERS *****
 * $Id: wikipedia_preferences_templates.js,v 1.11 2006/04/21 15:09:16 froebel Exp $
 * ***** END CVS HEADERS ***** */

var count;
var tcount;

function onLoadPageTemplates() {
	count = wbPrefs.getIntPref(OPTION_USER_TEMPLATE_CAT+".count");
	tcount = wbPrefs.getIntPref(OPTION_USER_TEMPLATE+".count");
	if ((tcount == 0) && (count == 0)) {
		document.getElementById('templates-tree-user').disabled = true;
	}
	loadCategory();
	loadTemplates();
}

/************ LOAD AREA *************/

function loadCategory() {
	var wbPrefs = getPreferences();
	var count = wbPrefs.getIntPref(OPTION_USER_TEMPLATE_CAT+".count");
	for (var i = 0; i< count; i++) {
		var catid = decodeURIComponent(wbPrefs.getCharPref(OPTION_USER_TEMPLATE_CAT+"."+i+".cat"));
		var label = decodeURIComponent(wbPrefs.getCharPref(OPTION_USER_TEMPLATE_CAT+"."+i+".label"));
		var parent = decodeURIComponent(wbPrefs.getCharPref(OPTION_USER_TEMPLATE_CAT+"."+i+".parent"));
		addCatTemplateItem(label,catid,parent);
	}
}

function loadTemplates() {
	var wbPrefs = getPreferences();
	var tcount = wbPrefs.getIntPref(OPTION_USER_TEMPLATE+".count");
	for (var i = 0; i < tcount; i++) {
		var cat = decodeURIComponent(wbPrefs.getCharPref(OPTION_USER_TEMPLATE+"."+i+".cat"));
		var label = decodeURIComponent(wbPrefs.getCharPref(OPTION_USER_TEMPLATE+"."+i+".label"));
		var text = decodeURIComponent(wbPrefs.getCharPref(OPTION_USER_TEMPLATE+"."+i+".text"));
		var tooltip = decodeURIComponent(wbPrefs.getCharPref(OPTION_USER_TEMPLATE+"."+i+".tooltip"));
		addTemplateItem(cat,label,text,tooltip);
	}
}

/******** ADD AREA ********/

function addCatTemplateItem(label,cat,parent) {
	if (document.getElementById('templates-tree-user').disabled) {
		document.getElementById('templates-tree-user').disabled = false;
	}
	var item = document.createElement('treeitem');
	var row = document.createElement('treerow');
	var cell = document.createElement('treecell');
	var child = document.createElement('treechildren');
	//	treecell
	cell.setAttribute("label", label);
	cell.setAttribute("parent", parent);
	cell.setAttribute("cat", cat);
	cell.setAttribute("area", "cats");
	row.appendChild(cell);
	//	treeitem
	item.setAttribute("id", 'templates-cat-' + cat);
	item.setAttribute("open", "false");
	item.setAttribute("container", "true");
	item.appendChild(row);
	//	the child
	child.setAttribute("id", 'templates-cat-list-' + cat);
	item.appendChild(child);
	if (parent != "undefined") {
		document.getElementById('templates-cat-list-' + parent).appendChild(item);
	} else {
		document.getElementById('templates-user').appendChild(item);
	}
}

function addTemplateItem(catid,label,text,tooltip) {
	var item = document.createElement('treeitem');
	var row = document.createElement('treerow');
	var cell = document.createElement('treecell');
	//	row settings
	row.setAttribute("id", 'templates-cat-list-row-' + catid);
	//	cell settings
	cell.setAttribute("src", "chrome://wikipedia/skin/images/select_off.gif");
	cell.setAttribute("area", 'tmpl');
	cell.setAttribute("cat", catid);
	cell.setAttribute("name", label);
	cell.setAttribute("text", text);
	cell.setAttribute("tooltip", tooltip);
	row.appendChild(cell);
	cell = document.createElement('treecell');
	cell.setAttribute("id", 'templates-cat-list-row-treecell-name-' + catid)
	cell.setAttribute("label", label);
	row.appendChild(cell);
	cell = document.createElement('treecell');
	cell.setAttribute("id", 'templates-cat-list-row-treecell-text-' + catid)
	cell.setAttribute("label", text);
	row.appendChild(cell);
	cell = document.createElement('treecell');
	cell.setAttribute("id", 'templates-cat-list-row-treecell-tooltip-' + catid)
	cell.setAttribute("label", tooltip);
	row.appendChild(cell);
	//	item settings
	item.setAttribute("id", 'templates-cat-list-item-' + catid);
	item.appendChild(row);
	if (catid != "undefined") {
		document.getElementById('templates-cat-list-' + catid).appendChild(item);
	} else {
		document.getElementById('templates-user').appendChild(item);
	}
}

/******* ADD AREA DIALOG ************/

function addUserCatTemplate() {
	var ok = [false];
	var params = ["",""];
	window.openDialog("chrome://wikipedia/content/wikipedia_template_cat_properties.xul", "&wikipedia.template.dialogtitle;","chrome,modal,centerscreen,resizable",ok,params);
	if (ok[0]) {
		var label = params[0];
		var catid = params[1];
		var parent = params[2];
		addCatTemplateItem(label,catid,parent);
	}
	store_cats('templates-user');
}

function addUserTemplate() {
	var ok = [false];
	var params = ["","","",""];
	window.openDialog("chrome://wikipedia/content/wikipedia_template_properties.xul", "&wikipedia.template.dialogtitle;","chrome,modal,centerscreen,resizable",ok,params);
	if (ok[0]){
		var cat = params[0];
		var label= params[1];
		var text = params[2];
		var tooltip = params[3];
		addTemplateItem(cat,label,text,tooltip);
	}
	store_tmpl('templates-user');
}


/*************** EDIT AREA **************/

function editUserTemplate() {
	var tree = document.getElementById('templates-tree-user');
	var item = tree.view.getItemAtIndex(tree.currentIndex);
	var active = item.firstChild.firstChild;
	if (active.getAttribute('area') == "tmpl") {
		// this a template file, not a cat
		var oldcat = active.getAttribute("cat");
		var label = active.getAttribute("name");
		var text = active.getAttribute("text");
		var tooltip = active.getAttribute("tooltip");
		
		var ok = [false];
		var params = [oldcat,label,text,tooltip];
		window.openDialog("chrome://wikipedia/content/wikipedia_template_properties.xul", "&wikipedia.template.dialogtitle;","chrome,modal,centerscreen,resizable",ok,params);
		if (ok[0]) {
			cat = params[0];
			label = params[1];
			text = params[2];
			tooltip = params[3];
			//	check to see if we changed the cat. Then we got to delete 
			//	the last item add run the "addTemplateItem" command instead
			if (oldcat != cat) {
				if (oldcat != "undefined") {
					document.getElementById('templates-cat-list-' + oldcat).removeChild(item);
				} else {
					document.getElementById('templates-user').removeChild(item);
				}
				addTemplateItem(cat,label,text,tooltip);
			} else {
				// else
				//	the store code
				active.setAttribute("src", "chrome://wikipedia/skin/images/select_off.gif");
				active.setAttribute("area", 'tmpl');
				active.setAttribute("cat", cat);
				active.setAttribute("name", label);
				active.setAttribute("text", text);
				active.setAttribute("tooltip", tooltip);
				//	display settings
				document.getElementById('templates-cat-list-row-treecell-name-' + cat).setAttribute("label", label);
				document.getElementById('templates-cat-list-row-treecell-text-' + cat).setAttribute("label", text);
				document.getElementById('templates-cat-list-row-treecell-tooltip-' + cat).setAttribute("label", tooltip);
			}
		}
		store_tmpl('templates-user');
	}
	if (active.getAttribute('area') == "cats") {
		//	this is a catagory
		var cat = item.firstChild.firstChild.getAttribute("cat");
		var label = item.firstChild.firstChild.getAttribute("label");
		var parent = item.firstChild.firstChild.getAttribute("parent");
		
		var ok = [false];
		var params = [cat,label,parent, "edit"];
		window.openDialog("chrome://wikipedia/content/wikipedia_template_cat_properties.xul", "&wikipedia.template.dialogtitle;","chrome,modal,centerscreen,resizable",ok,params);
		
	}
}

/*************** DELETE AREA **************/

function deleteUserTemplate() {
	var tree = document.getElementById('templates-tree-user');
	var item = tree.view.getItemAtIndex(tree.currentIndex);
	var active = item.firstChild.firstChild;
	//	add a check here to confirm
	if (active.getAttribute('area') == "cats") {
		if (active.getAttribute('parent') != "undefined") {
			document.getElementById('templates-cat-list-' + active.getAttribute('parent')).removeChild(item);
		} else {
			document.getElementById('templates-user').removeChild(item);
		}
		store_cats('templates-user');
		store_tmpl('templates-user');
	}
	if (active.getAttribute('area') == "tmpl") {
		if (active.getAttribute('cat') != "undefined") {
			document.getElementById('templates-cat-list-' + active.getAttribute('cat')).removeChild(item);
		} else {
			document.getElementById('templates-user').removeChild(item);
		}
		store_tmpl('templates-user');
	}
}

function enableDeleteUserTemplate(e) {
	var tree = document.getElementById('templates-tree-user');
	if (tree.currentIndex < 0) {
		return false;
	}
	var item = tree.view.getItemAtIndex(tree.currentIndex);
	var active = item.firstChild.firstChild;
	
	if (active.getAttribute('area') == "cats") {
		document.getElementById('template-edit-cat-user').disabled=!e;
		document.getElementById('template-delete-cat-user').disabled=!e;
	} else {
		document.getElementById('template-edit-cat-user').disabled=e;
		document.getElementById('template-delete-cat-user').disabled=e;	
	}

	if (active.getAttribute("area") == "tmpl") {
		document.getElementById('template-edit-user').disabled=!e;
		document.getElementById('template-delete-user').disabled=!e;
	} else {
		document.getElementById('template-edit-user').disabled=e;
		document.getElementById('template-delete-user').disabled=e;
	}
}

/*************** STORE AREA **************/

function save_usertmpl(cArray, value) {
	for (var i = 0; i < cArray.length; i++) {
		var usertmpl = cArray[i].firstChild.firstChild;
		var usertmplchild = cArray[i].childNodes[1];
		if ((usertmpl.getAttribute('area') == "cats") && (value == "cats")) {
			wbPrefs.setCharPref(OPTION_USER_TEMPLATE_CAT+"."+count+".cat",encodeURIComponent(usertmpl.getAttribute("cat")));
			wbPrefs.setCharPref(OPTION_USER_TEMPLATE_CAT+"."+count+".label",encodeURIComponent(usertmpl.getAttribute("label")));
			wbPrefs.setCharPref(OPTION_USER_TEMPLATE_CAT+"."+count+".parent",encodeURIComponent(usertmpl.getAttribute("parent")));
			count = count+1;
		}
		if ((usertmpl.getAttribute('area') == "tmpl") && (value == "tmpl")) {	
			wbPrefs.setCharPref(OPTION_USER_TEMPLATE+"."+tcount+".cat",encodeURIComponent(usertmpl.getAttribute("cat")));
			wbPrefs.setCharPref(OPTION_USER_TEMPLATE+"."+tcount+".label",encodeURIComponent(usertmpl.getAttribute("name")));
			wbPrefs.setCharPref(OPTION_USER_TEMPLATE+"."+tcount+".templatecode", "false");	
			wbPrefs.setCharPref(OPTION_USER_TEMPLATE+"."+tcount+".text",encodeURIComponent(usertmpl.getAttribute("text")));
			wbPrefs.setCharPref(OPTION_USER_TEMPLATE+"."+tcount+".tooltip",encodeURIComponent(usertmpl.getAttribute("tooltip")));
			tcount = tcount+1;
		}
		if (usertmplchild) {
			if (usertmplchild.childNodes.length > 0) {
				save_usertmpl(usertmplchild.childNodes, value); 
			}	
		}
	}
	if (value == "cats") {
		wbPrefs.setIntPref(OPTION_USER_TEMPLATE_CAT+".count",count);
	}
	if (value == "tmpl") {
		wbPrefs.setIntPref(OPTION_USER_TEMPLATE+".count",tcount);
	}
}

function store_cats(treeName) {
	count = 0;
	var tree = document.getElementById(treeName).childNodes;
	save_usertmpl(tree, 'cats'); 
}

function store_tmpl(treeName) {
	tcount = 0;
	var tree = document.getElementById(treeName).childNodes;
	save_usertmpl(tree, 'tmpl'); 
}

/************ EXPAND FUNCTIONS ***********/

function set_children_value(cArray, name, value) {
	for(var i = 0; i < cArray.length; i++) {
		cArray[i].setAttribute(name, value);
		if (cArray[i].childNodes[1]) {
			if (cArray[i].childNodes[1].childNodes.length > 0) {
				set_children_value(cArray[i].childNodes[1].childNodes, name, value); 
			}	
		}
	}
}

function expand_tree(treeName) {
	var tree = document.getElementById(treeName).childNodes;
	set_children_value(tree, 'open', 'true'); 
}

function collapse_tree(treeName) {
	var tree = document.getElementById(treeName).childNodes;
	set_children_value(tree, 'open', 'false'); 
}