/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distribselectGameuted on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Wikipedia Toolbar.
 *
 * The Initial Developer of the Original Code is
 * Bananeweizen
 *
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Shane A. Froebel <shane.froebel@gmail.com/bugs@bugssite.org>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 /* ***** CVS HEADERS *****
 * $Id: wikipedia_preferences_user.js,v 1.5 2006/04/21 15:09:16 froebel Exp $
 * ***** END CVS HEADERS ***** */

var wbPrefs = null;

function onLoadPageUser() {
	wbPrefs = getPreferences();
	loadStandardWikis();
}

/************ LOAD AREA *************/

function loadStandardWikis() {
	var projects = ['wikipedia','wiktionary','wikibooks','wikiquote','wikisource','wikinews','special'];
	var nodelist = getNodes("chrome://wikipedia/content/wiki_projects.xml","/languages/language");
	for (var i = 0; i < nodelist.length; i++) {
		var nodewiki = nodelist[i];
		try {
			var lang = document.evaluate("code/text()",nodewiki,null,0,null).iterateNext().nodeValue;;
		}
		catch(e) {
			lang = "";
		}
		var name = document.evaluate("name/text()",nodewiki,null,0,null);
		var english = document.evaluate("name_english/text()",nodewiki,null,0,null);
		name = name.iterateNext().nodeValue;
		english = english.iterateNext().nodeValue;
		var p = 0;
		for (var p = 0; p < projects.length; p++) {
			try {
				var loc = document.evaluate(projects[p]+"/text()",nodewiki,null,0,null).iterateNext().nodeValue;
			}
			catch (e) {
			}
			if (loc != null) {	//	is there...
				addStandardWiki(projects[p], lang, name, english, loc);
			}
		}
	}
}

function resetWikiHeaders() {
	var projects = ['wikipedia','wiktionary','wikibooks','wikiquote','wikisource','wikinews','special'];
	var projectsnames = ['Wikipedia','Wiktionary','Wikibooks','Wikiquote','Wikisource','Wikinews','Wikimedia'];
	for (var i = 0; i < projects.length; i++) {
		document.getElementById('wiki-projects-'+projects[i]).setAttribute("label", projectsnames[i]);
	}
}

/******** ADD AREA ********/

function addStandardWiki(parentId, code, language, english, loc) {
	var item = document.createElement('treeitem');
	var row = document.createElement('treerow');
	var cell = document.createElement('treecell');
	
	var select_image = IMAGE_OFF;
	var count_active = wbPrefs.getIntPref(OPTION_ACTIVE+".count");
	for (var i = 0; i < count_active; i++) {
		var active_url = wbPrefs.getCharPref(OPTION_ACTIVE+"."+i+".url");
		if (active_url == loc) {
			select_image = IMAGE_ON;
			cell.setAttribute("enabled", "true");
		} else {
			cell.setAttribute("enabled", "false");
		}
	}
	//	row settings
	row.setAttribute("id", 'project-area-' + parentId);
	// cell settings (store data here)
	cell.setAttribute("id", 'project-area-id-' + parentId + '-lang-' + code);
	cell.setAttribute("src", select_image);
	cell.setAttribute("code", code);
	cell.setAttribute("lang", language);
	cell.setAttribute("english", english);
	cell.setAttribute("area", "stdwiki");
	cell.setAttribute("url", loc);
	
	row.appendChild(cell);
	cell = document.createElement('treecell');
	cell.setAttribute("label", code);
	row.appendChild(cell);
	cell = document.createElement('treecell');
	cell.setAttribute("label", language);
	row.appendChild(cell);
	cell = document.createElement('treecell');
	cell.setAttribute("label", english);
	row.appendChild(cell);
	cell = document.createElement('treecell');
	cell.setAttribute("label", loc);
	row.appendChild(cell);
	//	item settings
	item.setAttribute("id", 'project-area-item-' + parentId);
	item.appendChild(row);
	//	append to the childen
	document.getElementById('projects-'+parentId).appendChild(item);
}

/******* CLICK AREA ************/

function clickStandardWiki(e) {
	var tree = document.getElementById('mediawiki-tree-standard');
	var item = tree.view.getItemAtIndex(tree.currentIndex);
	var active = item.firstChild.firstChild;
	if (active.getAttribute('area') == "stdwiki") {
		var image = active.getAttribute("src");
		if (image == IMAGE_OFF) {
			active.setAttribute("src", IMAGE_ON);
			active.setAttribute("enabled", "true");
		} else {
			active.setAttribute("src", IMAGE_OFF);
			active.setAttribute("enabled", "false");
		}
		//	everytime we click, save..
		store_stdwiki('mediawiki-tree-standard');
	}
}

/*************** STORE AREA **************/

function save_wiki(cArray, value) {
	for (var i = 0; i < cArray.length; i++) {
		var userwiki = cArray[i].firstChild.firstChild;
		var userwikichild = cArray[i].childNodes[1];
		if ((userwiki.getAttribute('area') == "stdwiki") && (value == "stdwiki")) {
			if (userwiki.getAttribute('enabled') == "true") {
				wbPrefs.setCharPref(OPTION_ACTIVE+"."+count+".url",encodeURIComponent(userwiki.getAttribute("url")));
				wbPrefs.setCharPref(OPTION_ACTIVE+"."+count+".label",encodeURIComponent(userwiki.getAttribute("english") + " (" + userwiki.getAttribute("code") + ")"));
				wbPrefs.setCharPref(OPTION_ACTIVE+"."+count+".language",encodeURIComponent(userwiki.getAttribute("lang")));	
				count = count+1;
			}
		}		
		if (userwikichild) {
			if (userwikichild.childNodes.length > 0) {
				save_wiki(userwikichild.childNodes, value); 
			}	
		}
	}
	if (value == "stdwiki") {
		wbPrefs.setIntPref(OPTION_ACTIVE+".count",count);
	}
}

function store_stdwiki(treeName) {
	count = 0;
	var tree = document.getElementById(treeName).childNodes;
	save_wiki(tree, 'stdwiki'); 
}