/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distribselectGameuted on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Wikipedia Toolbar.
 *
 * The Initial Developer of the Original Code is
 * Bananeweizen
 *
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Shane A. Froebel <shane.froebel@gmail.com/bugs@bugssite.org>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 /* ***** CVS HEADERS *****
 * $Id: wikipedia_template_cat_properties.js,v 1.5 2006/04/21 15:09:16 froebel Exp $
 * ***** END CVS HEADERS ***** */

var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
var wpPrefBranch = prefService.getBranch("wikipedia."); // preferences wikipedia node
var OPTION_USER_TEMPLATE = "usertemplate";
var OPTION_USER_TEMPLATE_CAT = "usertemplatecat";

function onLoad() {
	var params = window.arguments[1];
	document.getElementById('template-text').value = params[0];
	document.getElementById('template-label').value = params[1];
	if (params[3] == "edit") {
		populateCats(params[2], params[0]);
		if (params[2] != "undefined") {
			document.getElementById('wikipedia.changeparent').hidden = false;
		}
		document.getElementById('template-text').disabled = true;
		document.getElementById('template-list').disabled = true;
	} else {
		populateCats(params[2]);
	}
	document.getElementById('template-label').focus();
}

function updateTemplateSelection() {
	var disabled = !document.getElementById('wikipedia.changeparent').checked;
	document.getElementById('template-list').disabled = disabled;
}

function populateCats(value, currentcat) {
	var num = wpPrefBranch.getIntPref(OPTION_USER_TEMPLATE_CAT+".count");
	var list = document.getElementById("template-list");
	var popup = document.getElementById("template-parent");
	var item;

	while (popup.hasChildNodes())
	{
		popup.removeChild(popup.lastChild);
	}

	for (var i = 0; i < num; i++) {
		var item = document.createElement("menuitem");
		item.setAttribute("value", decodeURIComponent(wpPrefBranch.getCharPref(OPTION_USER_TEMPLATE_CAT+"."+i+".cat")));
		item.setAttribute("label", decodeURIComponent(wpPrefBranch.getCharPref(OPTION_USER_TEMPLATE_CAT+"."+i+".label")));
		
		if (currentcat != decodeURIComponent(wpPrefBranch.getCharPref(OPTION_USER_TEMPLATE_CAT+"."+i+".cat"))) {
			if (value == decodeURIComponent(wpPrefBranch.getCharPref(OPTION_USER_TEMPLATE_CAT+"."+i+".cat"))) {
				list.selectedItem = item;
			}
			popup.appendChild(item);			
		}
	}
}

function onAccept() {
	var ok = window.arguments[0];
	var params = window.arguments[1];
	params[0] = document.getElementById('template-label').value;
	params[1] = document.getElementById('template-text').value;
	params[2] = document.getElementById('template-list').selectedItem.value;
	ok[0] = true;
	return true;
}

function onCancel() {
	var ok = window.arguments[0]; 
	ok[0] = false;
	return true;
}